#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// spandsp
#include <spandsp.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef WIN32
#define EXPORT __declspec(dllexport)
#else
#define EXPORT
#endif

typedef int (*plugin_exec_cmd)(int argc, ...);  // dtmfbox commmands 
plugin_exec_cmd dtmfbox;                        

#define app_msg(x)  dtmfbox(2, "-log1", x)      // Logging
#define app_err(x)  dtmfbox(2, "-log2", x)
#define app_dbg(x)  dtmfbox(2, "-log3", x)
#define app_dbg2(x) dtmfbox(2, "-log4", x)
#define app_dbg3(x) dtmfbox(2, "-log5", x)

#define SPANDSP_VERSION 5
#define CAPI_CONNECTIONS 20
#define BUFFER_CNT 1

EXPORT void plugin_init(plugin_exec_cmd cmd);
EXPORT void plugin_close();
EXPORT void plugin_event(char *scriptfile, char *s_event, char *s_direction, char *s_type, int conid_src, int conid_dst, char *no_src, char *no_dst, char *data, int acc_id);
EXPORT void plugin_output(char *output, int pid);
EXPORT void plugin_get_frame(char *buf, int buf_size, int conid, int playid, int accid);
EXPORT void plugin_put_frame(char *buf, int buf_size, int conid, int recid, int accid);
EXPORT char *plugin_extra_help();
EXPORT int plugin_extra_commands(int argc, char *arg[], int pid);

typedef struct capifax_con_t
{
	fax_state_t		fax;
					
	char			src_no[64];
	char			trg_no[64];
		
	int			    sending;
	int			    running;	
	int             type;

	int			    pages;			
	char		    buf[320 * BUFFER_CNT];	
} 
capifax_con_t;

static int spandsp_init(int con, const char *tiff_file, int sending, int modem, int ecm, const char *LSI, const char *LocalHeaderInfo);
static int spandsp_close(int con);

#if SPANDSP_VERSION == 5
static int	phase_b_handler (t30_state_t *s, void *user_data, int result);
static int	phase_d_handler (t30_state_t *s, void *user_data, int result);
#else
static void	phase_b_handler (t30_state_t *s, void *user_data, int result);
static void	phase_d_handler (t30_state_t *s, void *user_data, int result);
#endif
static void	phase_e_handler (t30_state_t *s, void *user_data, int result);

static void dbg(int level, const char *format, ...);

#ifdef __cplusplus
}
#endif