/*********************************************************************************
 * menu.plugin.h ($Revision: 241 $)
 *
 * Copyright (c) 2006-2009 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#ifdef __DTMFBOX_MENU_PLUGIN_C
#define __EXTERN
#else
#define __EXTERN extern
#endif

#ifdef WIN32
#include <windows.h>
#include <process.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>

#ifndef WIN32
    #include <unistd.h>
    #include <sys/types.h>
    #include <sys/wait.h>
#endif

#include "globals.h"                           // Global structs for this plugin

typedef int (*plugin_exec_cmd)(int argc, ...);
typedef void* (*plugin_exec_lib)(void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*, void*);

__EXTERN plugin_exec_cmd dtmfbox;              // Execute dtmfbox commands (as on console)
__EXTERN plugin_exec_lib external_lib;         // Call external lib reflective (call any functionname with any args.. ok most ;)).

__EXTERN dtmfbox_connection cons[MAX_CONS];    // Current connections
__EXTERN dtmfbox_settings sets;                // Global settings
__EXTERN menu_t **menus;                       // Menues 
__EXTERN unsigned menu_count;                  // Menu count

#define app_msg(x)  dtmfbox(2, "-log1", x)     // Logging
#define app_err(x)  dtmfbox(2, "-log2", x)
#define app_dbg(x)  dtmfbox(2, "-log3", x)
#define app_dbg2(x) dtmfbox(2, "-log4", x)
#define app_dbg3(x) dtmfbox(2, "-log5", x)

#ifdef __cplusplus
extern "C" {
#endif

#ifdef WIN32    
    #define EXPORT __declspec(dllexport)
    #define snprintf _snprintf
    #define usleep(x) Sleep(x);
#else
    #include <dlfcn.h>
    #include <sys/resource.h>
 
    #define EXPORT
    #define HMODULE void*
    #define LoadLibraryA(a)         dlopen(a, RTLD_LAZY);
    #define GetProcAddress(a, b)    dlsym(a, b);
    #define FreeLibrary(a)          dlclose(a);
#endif

EXPORT void plugin_init(plugin_exec_cmd cmd);
EXPORT void plugin_close();
EXPORT void plugin_event(char *scriptfile, char *s_event, char *s_direction, char *s_type, int conid_src, int conid_dst, char *no_src, char *no_dst, char *data, int acc_id);
//EXPORT void plugin_output(char *output, int pid);
EXPORT char *plugin_extra_help();

#ifdef __cplusplus
}
#endif
