/*********************************************************************************
 * template.plugin.h($Revision$)
 *
 * Copyright (c) 2006-2009 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

#define TEMPLATE_PLUGIN_VERSION "0.1"

#ifdef WIN32
#define EXPORT __declspec(dllexport)
#else
#define EXPORT
#endif

typedef int (*plugin_exec_cmd)(int argc, ...);  // dtmfbox commmands 
plugin_exec_cmd dtmfbox;                        

#define app_msg(x)  dtmfbox(2, "-log1", x)      // Logging
#define app_err(x)  dtmfbox(2, "-log2", x)
#define app_dbg(x)  dtmfbox(2, "-log3", x)
#define app_dbg2(x) dtmfbox(2, "-log4", x)
#define app_dbg3(x) dtmfbox(2, "-log5", x)

EXPORT void plugin_init(plugin_exec_cmd cmd);
EXPORT void plugin_close();
EXPORT void plugin_event(char *scriptfile, char *s_event, char *s_direction, char *s_type, int conid_src, int conid_dst, char *no_src, char *no_dst, char *data, int acc_id);
EXPORT void plugin_output(char *output, int pid);
EXPORT void plugin_get_frame(char *buf, int buf_size, int conid, int playid, int accid);
EXPORT void plugin_put_frame(char *buf, int buf_size, int conid, int recid, int accid);
EXPORT char *plugin_extra_help();
EXPORT int plugin_extra_commands(int argc, char *arg[], int pid);

#ifdef __cplusplus
}
#endif
