/*********************************************************************************
 * plugins.h ($Revision: 250 $)
 *
 * Copyright (c) 2006-2009 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

// Plugins (*.dll, *.so)
#define MAX_PLUGINS 64

HMODULE plugins[MAX_PLUGINS];
int plugin_count;

typedef int (*plugin_exec_command)(int argc, ...);

typedef void (*plugin_init)(plugin_exec_command cmd);
typedef void (*plugin_close)(void);
typedef void (*plugin_event)(char *scriptfile, char *s_event, char *direction, char *type, int conid_src, int conid_dst, char *no_src, char *no_dst, char *data, int acc_id);
typedef void (*plugin_output)(char *output, int pid);
typedef void (*plugin_get_frame)(char *buf, int buf_size, int conid, int playid, int accid);
typedef void (*plugin_put_frame)(char *buf, int buf_size, int conid, int recid, int accid);
typedef int (*plugin_extra_commands)(int argc, char *arg[], int pid);
typedef char *(*plugin_extra_help)(void);

plugin_event plugin_proc_event[MAX_PLUGINS];
plugin_output plugin_proc_output[MAX_PLUGINS];
plugin_get_frame plugin_proc_get_frame[MAX_PLUGINS];
plugin_put_frame plugin_proc_put_frame[MAX_PLUGINS];
plugin_extra_commands plugin_proc_extra_commands[MAX_PLUGINS];
plugin_extra_help plugin_proc_extra_help[MAX_PLUGINS];

int plugin_execute_cmd(int argc, ...);

void plugins_init();
void plugins_close();
void plugin_raise_event(script_event_t script_event, char *s_event, char *s_direction, char *s_type, char *no_src, char *no_dst, char *data);
void plugin_raise_output(char *output, int pid);
void plugin_raise_get_frame(char *buf, int buf_size, int conid, int playid, int accid);
void plugin_raise_put_frame(char *buf, int buf_size, int conid, int recid, int accid);
void plugin_raise_extra_help(int pipe_id);
int plugin_raise_extra_commands(int argc, char *arg[], int pid);
