/*********************************************************************************
 * voip_ctrl.h ($Revision: 250 $)
 *
 * Copyright (c) 2006-2009 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

int voip_init();                                         // Initialize VoIP
int voip_close();                                        // Destroy VoIP
void voip_listen();                                      // VoIP listen loop (thread)
void voip_handle_events(int msec);                       // Handle VoIP messages

pj_status_t dns_resolver_create();
pj_status_t udp_server_create(pj_sockaddr_in *p_pub_addr);
pj_status_t stun_server_resolve(int wait);
pj_status_t voip_codecs_init();

#if DTMFBOX_USE_VOIP    
pj_status_t ice_media_transports_create(pj_sockaddr_in *p_pub_addr);
pj_status_t udp_media_transports_create(pj_sockaddr_in *p_pub_addr);
#endif

