/*********************************************************************************
 * voip_events.h ($Revision: 250 $)
 *
 * Copyright (c) 2006-2009 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#if DTMFBOX_USE_VOIP

// Callback to be called when SDP negotiation is done in the call
void call_on_media_update( pjsip_inv_session *inv, pj_status_t status);

// Callback to be called when invite session's state has changed
void call_on_state_changed( pjsip_inv_session *inv, pjsip_event *e);

// Callback to be called when dialog has forked:
void call_on_forked(pjsip_inv_session *inv, pjsip_event *e);

// Callback to be called when tsx state changed
// void call_on_tsx_changed(pjsip_inv_session *inv, pjsip_transaction *tsx, pjsip_event *e);

// Callback to be called when dtmf signals arrived
void dtmf_callback(pjmedia_stream *strm, void *user_data, int digit);

// RX request callback (incoming call). Before SDP negotation..
pj_bool_t on_rx_request( pjsip_rx_data *rdata );

void registrar_connect_outgoing(void* args);

// Module for this app (client)
static pjsip_module mod_dtmfbox =
{
    NULL, NULL,              // prev, next.
    { "dtmfbox", 7 },        // Name.
    -1,                      // Id
    PJSIP_MOD_PRIORITY_APPLICATION+1, // App priority
    NULL,                    // load()
    NULL,                    // start()
    NULL,                    // stop()
    NULL,                    // unload()
    &on_rx_request,          // on_rx_request()
    NULL,                    // on_rx_response()
    NULL,                    // on_tx_request()
    NULL,                    // on_tx_response()
    NULL                     // on_tsx_state()
};

#endif
