/*********************************************************************************
 * voip_funcs.h ($Revision: 250 $)
 *
 * Copyright (c) 2006-2009 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

int voip_call(connection_t *mCON, char *no_source, char *no_target, int call_anonymous, char *scriptfile, char *delimiter);
int voip_hangup(connection_t *mCON);
void voip_confirm_call(connection_t *mCON);
void voip_send_dtmf(unsigned char dtmf, int con_id);
void voip_get_dtmf(unsigned char dtmf, int ddi, int con_id);
void voip_remove_media_session(connection_t *mCON);
int voip_get_acc_incoming(pjsip_rx_data *rdata, char *hdr_from, char *hdr_to);
int voip_get_acc_outgoing(pjsip_rx_data *rdata, char *hdr_from, char *hdr_to);

int voip_check_type(pjsip_rx_data *rdata, int *accountid, int *clientid, int *incoming_direct, int *incoming_account, int *incoming_registrar, int *outgoing_registrar, char from[MAX_URI_LENGTH], char to[MAX_URI_LENGTH]);
connection_t * voip_alert_call(pjsip_rx_data *rdata);

pj_status_t voip_resolve_transport_address(char *addr, int *port);
pj_status_t voip_create_uac_contact(pj_pool_t *pool, pj_str_t *contact, int acc_id, const pj_str_t *suri);
pj_status_t voip_create_uas_contact(pj_pool_t *pool, pj_str_t *contact, int acc_id, pjsip_rx_data *rdata);
